import 'package:get/get.dart';
import 'package:wowit/common.dart';

abstract class BaseController extends GetxController {
  final Map<String, List<Map<String, Object>>> _data = {};

  bool isComponent = true; //default component ui
  bool isOnline = true;
  Map<String, Object> messageIdBackUp = {};

  Future<Map<String, List<Map<String, Object>>>> loadData();

  @override
  void onInit() {
    if (Common.supperAdmin && !isComponent) {
      messageIdBackUp = {};
      Common.messageIdBackUp = {};
    }

    super.onInit();
  }

  void onInitGetX() {
    printInfo(info: this.toString() + " onInitGetX");
  }

  Map<String, List<Map<String, Object>>> getData() {
    return _data;
  }

  void setData(Map<String, List<Map<String, Object>>> data) {
    _data.clear();
    if (data != null) {
      _data.addAll(data);
    }
  }

  void clearData() {
    _data.clear();
  }

  void setIsOnline(bool _isOnline) {
    if (_isOnline != this.isOnline) {
      this.isOnline = _isOnline;
      update();
    }
  }
}
