import 'package:wowit/message.dart';
import 'package:flutter/material.dart';

import '../methods.dart';

enum TextPosition {
  Left,
  Right,
  Top,
  Bottom
}

enum TextAlignment {
  Left,
  Right,
}
enum CtrlTyp {
  NONE ,
  Text ,
  CheckBox  ,
  DateTime  ,
  DropDown  ,
  Memo  ,
  Numeric ,
  Picture  ,
  UploadFile  ,
  YoutubeKey  ,
  Time  ,
  MultiCheck ,
  NumericLong ,
  WowGrid  ,
  Int ,
  Date ,
  TempField ,
}

class BaseLayoutModel {

  final Map<String, Object> data;
  final BuildContext context;
  Widget control;
//region Field

  int  id = -1;
  bool isVisible = true;
  String messageId;
  CtrlTyp ctrlTyp = CtrlTyp.Text;
  int  idSkin = -1;

  int  flex;
  int  maxLine;// = maxLine

  String hexTextColor = "#2e2e2e";
  String hexBackgroundColor = "#ffffff";
  int idIcon = -1;
  TextPosition textPosition = TextPosition.Left;
  TextAlignment textAlign = TextAlignment.Left;



//endregion


//region Properties
  Object get editValue {
    return null;
  }
  String get title {
    if(this.messageId == null) return "";
    return Message.getMessage(this.messageId);
  }
  String get hint {
    if(this.messageId == null) return "";
    return Message.getMessage("HINT_" + this.messageId);
  }
  String get invalidMessage {
    if(this.messageId == null) return "";
    return Message.getMessage("INVALID_" + this.messageId);
  }
  String get toolTip {
    if(this.messageId == null) return "";
    return Message.getMessage("TOOLTIP_" + this.messageId);
  }
//endregion


  BaseLayoutModel(this.context,this.data) {
      this.id = Methods.getInt(this.data, "ID");
  }
}
