import 'package:flutter/material.dart';
import 'package:get/get.dart';

class ScreenMessage extends StatelessWidget{
  final Map<String,Object> data;

  const ScreenMessage({Key key,@required this.data}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: Colors.white,
        title: Text('Danh sách message',style: TextStyle(color: Color(0xff2a367e),fontSize: 20),),
        leading: IconButton(
        icon: Icon(
          Icons.arrow_back_ios_rounded,
          color: Color(0xff2a367e),
          size: 24.0,
        ),
        onPressed: () {
          Get.back();
        },
      )
      ),
      body: ListView.separated(
        itemCount: data.length,
        itemBuilder: (context, index) {
          String key = data.keys.elementAt(index);
          return Padding(
            padding: const EdgeInsets.all(8.0),
            child: Column(children: [
              Text('Key: $key'),
              Padding(
                padding: const EdgeInsets.only(left: 10),
                child: Text('Message: ${data[key]}'),
              )
            ],),
          );
        },
         separatorBuilder: (context, index) => Divider(),
      ),
    );
  }

}