import 'package:wowit/common.dart';
import 'package:wowit/methods.dart';
import 'package:wowit/sqlService.dart';

class ImageByID {
  static String prefsImage = 'prefImage';

  static String getUrlImage(int id) {
    String idImage = id.toString();
    if (Common.mapImageURL.containsKey(idImage)) {
      return Methods.getString(Common.mapImageURL, idImage);
    } else {
      return Common.DEFAULT_IMAGE_URL;
    }
  }

  static Future<void> initHinhAnh(
      dynamic prefs, List<Map<String, Object>> dtImage,
      {bool reload = false}) async {
    try {
      List<String> listLanguage = [];
      final pattern = "[(=-|";
      Map<String, String> valueImage = Map();
      if (prefs.getStringList(prefsImage) == null || reload) {
        if (dtImage == null || dtImage.isEmpty || reload) {
          var data = await SQLService.execute(
            'sp_getImage',
          );
          dtImage = Methods.getList(data, 'dsHinhAnh');
        }

        for (var item in dtImage) {
          listLanguage.add(Methods.getInt(item, 'ID').toString() +
              pattern +
              Methods.getString(item, 'hinhAnh_image_path'));
        }
        if (Common.uid > 0) {
          SQLService.execute('sp_setHasMapImage', params: {'@uid': Common.uid});
        }
        if (prefs.getStringList(prefsImage) != null) {
          prefs.remove(prefsImage);
        }
        prefs.setStringList(prefsImage, listLanguage);
      }
      for (var itemList in prefs.getStringList(prefsImage)) {
        var convert = itemList.split(pattern);
        if (convert != null && convert.length > 1) {
          String imageID = convert[0].toString().toUpperCase();
          if (!valueImage.containsKey(imageID)) {
            valueImage[imageID] = convert[1];
          }
        }
      }
      Common.mapImageURL = valueImage;
    } catch (ex) {
      print("initHinhAnh exception: " + ex.toString());
    }
  }
}
