import 'package:flutter/foundation.dart';
import 'package:wowit/common.dart';
import 'package:wowit/sqlService.dart';

import 'methods.dart';

class Message {
//get message by key
  static String getMessage(String key) {
    if (!Common.canGetMessage) {
      return key;
    }

    key = key.trim().toUpperCase();
    if (Common.showKeyMessage == true && Common.supperAdmin) {
      _setMessageBackUp(key, Common.mapMessageData[key]);
      return key;
    }

    if (Common.mapMessageData.containsKey(key)) {
      _setMessageBackUp(key, Common.mapMessageData[key]);
      return Common.mapMessageData[key];
    }

    // not exists -> auto create SQL
    if (kDebugMode && Common.autoCreateMessage) {
      SQLService.execute("sp_SyncMessage", params: {
        "@message": key,
        "@messageId": key,
        "@languageId": 1,
      });
    }

    Common.mapMessageData[key] = key;
    return key;
  }

  static void _setMessageBackUp(String key, Object message) {
    if (!Common.messageIdBackUp.containsKey(key)) {
      print('backUp key:$key, message: $message');
      Common.messageIdBackUp[key] = message;
    }
  }

  static void setLanguage(int languageCode) {
    Common.languageId = languageCode;
  }

  static String presLanguage = "language";
  static String presUseMessageFromSever = "messageSever";

  static Future<void> getMessageSQL(
      List<Map<String, Object>> dtLanguage,
      dynamic prefs,
      VoidCallback showWatting,
      VoidCallback hideWatting,
      Map<String, String> defaultMessage,
      {bool reload = false,
      bool useMessageFromSever = false}) async {
    final pattern =
        "[(=-|"; //cong key kho vao, de dam bao khong gap ky tu user su dung.

    int language = Common.languageId ?? 1;
    Map<String, String> valueMessage = Map();
    if (prefs.getStringList(presLanguage) == null || reload) {
      if (reload && showWatting != null) {
        showWatting.call();
      }
      List<String> listLanguage = [];

      if (dtLanguage == null || dtLanguage.isEmpty || reload) {
        var data = await SQLService.execute('getMessage',
            params: {'@languageId': language});
        dtLanguage = Methods.getList(data, 'language');
      }

      if (dtLanguage.length > 200) {
        SQLService.execute('sp_setHasMapMessage', params: {'@uid': Common.uid});

        for (var item in dtLanguage) {
          listLanguage.add(Methods.getString(item, 'messageId') +
              pattern +
              Methods.getString(item, 'message'));
        }
        if (prefs.getStringList(presLanguage) != null) {
          prefs.remove(presLanguage);
        }
        prefs.setStringList(presLanguage, listLanguage);

        for (var itemlist in prefs.getStringList(presLanguage)) {
          var convert = itemlist.split(pattern);
          if (convert != null && convert.length > 1) {
            String messageId = convert[0].toString().toUpperCase();
            if (!valueMessage.containsKey(messageId)) {
              valueMessage[messageId] = convert[1];
            }
          }
        }
      } else {
        valueMessage = defaultMessage;
      }
    } else {
      for (var itemlist in prefs.getStringList(presLanguage)) {
        var convert = itemlist.split(pattern);
        if (convert != null && convert.length > 1) {
          String messageId = convert[0].toString().toUpperCase();
          if (!valueMessage.containsKey(messageId)) {
            valueMessage[messageId] = convert[1];
          }
        }
      }
    }
    Common.initWowIT(
      valueMessage,
      Common.url_host,
    );
    if (reload && hideWatting != null) {
      hideWatting.call();
    }
  }
}
